
unit uMain2;

interface

uses
  Windows, Messages, Emailer, Menus, RxTray, StdCtrls, ComCtrls, Controls, Classes, Forms,
  LCDate, ExtCtrls, Mover, Buttons, Dialogs;

type
  TForm1 = class(TForm)
    RxTray1: TRxTray;
    SB1: TStatusBar;
    PM1: TPopupMenu;
    Checknow1: TMenuItem;
    Settings1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Emailer1: TEmailer;
    LCDate1: TLCDate;
    Active1: TMenuItem;
    N2: TMenuItem;
    SD1: TSaveDialog;
    MM1: TMainMenu;
    CheckNow2: TMenuItem;
    Settings2: TMenuItem;
    Hide1: TMenuItem;
    GetMessage1: TMenuItem;
    Else1: TMenuItem;
    Reply1: TMenuItem;
    Saveas1: TMenuItem;
    Delete1: TMenuItem;
    Abort1: TMenuItem;
    Exit2: TMenuItem;
    TC1: TTabControl;
    Memo2: TMemo;
    Panel3: TPanel;
    LFromC: TLabel;
    LToC: TLabel;
    LSubjectC: TLabel;
    LFrom: TLabel;
    LTo: TLabel;
    LSubject: TLabel;
    LDateC: TLabel;
    LDate: TLabel;
    Image1: TImage;
    N3: TMenuItem;
    N4: TMenuItem;
    Newmessage1: TMenuItem;
    N5: TMenuItem;
    Font1: TMenuItem;
    FD1: TFontDialog;
    procedure FormCreate(Sender: TObject);
    procedure BCheckClick(Sender: TObject);
    procedure BHideClick(Sender: TObject);
    procedure RxTray1Click(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Exit1Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure Checknow1Click(Sender: TObject);
    procedure Emailer1ActionDone(Sender: TObject; anAction: tEMAction);
    procedure Emailer1ActionStart(Sender: TObject; anAction: tEMAction);
    procedure BSetClick(Sender: TObject);
    procedure TC1Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Active1Click(Sender: TObject);
    procedure PM1Popup(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BSaveAsClick(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Reply1Click(Sender: TObject);
    procedure Newmessage1Click(Sender: TObject);
    procedure Emailer1GetPass(Sender: TObject; var aPass: String);
    procedure Font1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    Total   : Integer;
    LastR,
    LastS   : Integer;
    fActions: TStrings;
    fTotal  : Integer;
    fMessages : tStrings;
    fMsgIndex : Integer;
    fDelMsgInd: Integer;
    fMessageID: Integer;
    fDelMsgID : Integer;
    ThruMenu  : Boolean;
    Clicked   : Boolean;
    fEndQR    : Integer;
//    fPassOK   : Boolean;
    procedure TabChanged;
    procedure CheckDone;
    procedure AddAction(anAction: tEMAction);
    procedure DeleteAction(anAction: tEMAction);
    procedure ApplyMessage(const aMsg: string);
    function DoGetMessage: Boolean;
    procedure DoSend(const aTo, aBody: string);
    procedure WMQueryEnd(var aMessage: tWMQueryEndSession); message WM_QUERYENDSESSION;
    procedure SetFont;
  public
    { Public declarations }
    fLog: tStrings;
    procedure DoCheck;
    procedure DoDelete;
  end;

var
  Form1: TForm1;

implementation

uses
  SysUtils, HomeTool, uSet, uReply, uPass;

{$R *.DFM}

const
  saNames: array[tEMAction] of string = ('Idle', 'Checking mail', 'Getting message', 'Deleting message', 'Sending mail');

procedure TForm1.DoCheck;
begin
  Emailer1.CheckNow;
end;

const
  idEMailer	= $33786540;

procedure TForm1.FormCreate(Sender: TObject);
//var
//  lS: string;
begin
  fEndQR := 1;
  LastR  := -1;
  LastS  := -1;
  fActions  := TStringList.Create;
  fLog      := tStringList.Create;
  fMessages := tStringList.Create;
  SetWindowLong(Handle, GWL_USERDATA, idEMailer);
  RxTray1.Icon.Assign(Application.Icon);
  Total := 0;
  SB1.Panels[0].Text := 'not checked yet';
  fLog.Text := #13#10'EMer. Version 0.2.4a by Alek Shamrai (alexsh@adm.univd.kharkov.ua)'#13#10 +
	       '(Compiled: ' + Date2Str(LCDate1.LCDate) + ')'#13#10#13#10 +
	       'Special thanks to Yuri Guskov (ygheimth@adm.univd.kharkov.ua)'#13#10 +
	       '  for great improvements of EMer interface.'#13#10 +
	       #13#10 +
	       'tWSocket component (ver 2.37):'#13#10 +
	       '   Copyright (C) 1997 by Francois PIETTE <francois.piette@ping.be>'#13#10 +
	       '   WebSite: http://www.rtfm.be/fpiette/indexuk.htm'#13#10 +
	       ''#13#10 +
	       'RxTray component:'#13#10 +
	       '   Copyright (c) 1995, 1996 AO ROSNO'#13#10 +
	       '   Copyright (c) 1997 Master-Bank'#13#10;
  ThruMenu := False;
  RegLoadFont(FD1.Font, regAppName + '\BaseFont');
end;

procedure TForm1.BCheckClick(Sender: TObject);
begin
  DoCheck;
end;

procedure TForm1.BHideClick(Sender: TObject);
begin
  Hide;
end;

procedure TForm1.RxTray1Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Show;
  Application.BringToFront;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  if not Clicked then begin
    Clicked := True;
    {$B-}
    if not Form2.CB4.Checked or AskYN('Are you sure you want to quit?') then
    begin
      ThruMenu := True;
      Close;
    end;
    Clicked := False;
  end;
end;

procedure TForm1.Settings1Click(Sender: TObject);
begin
  Application.BringToFront;
  Form2.ShowModal;
end;

procedure TForm1.Checknow1Click(Sender: TObject);
begin
  DoCheck;
end;

procedure tForm1.CheckDone;
var
  i: Integer;
  R,
  S: Integer;
  Z: string;
begin
  if (Emailer1.ErrorCode[saGetStat] <> meOK) then Z := Emailer1.ErrorMessage[saGetStat]
  else begin
    Form4.fPassOK := True;
    R := EMailer1.TotalCount;
    SaveAs1.Enabled := False;
    Reply1.Enabled := False;
    GetMessage1.Enabled := False;
    if (R > 0) then begin
      RxTray1.Icon.Assign(Image1.Picture.Icon);
      Delete1.Enabled := True;
    end
    else begin
      RxTray1.Icon.Assign(Application.Icon);
      Delete1.Enabled := False;
    end;
    S := EMailer1.TotalSize;
    Z := IntToStr(S) + ' bytes in ' + IntToStr(R) + ' message(s)';
    if ((LastR <> R) or (LastS <> S)) then begin
      if Form2.CB3.Checked then fLog.Insert(0, TimeToStr(Time) + ' :=> ' + Z);
      TC1.Tabs.Clear;
      fMessages.Clear;
      if (R > 0) then
	for i := 0 to R - 1 do begin
	  fMessages.Add('');
	  TC1.Tabs.Add('Message #' + IntToStr(i));
	end;
      TabChanged;
      if (R > 0) and Form2.CB1.Checked then begin
	Show;
	Application.BringToFront;
      end;
    end;
    LastR := R;
    LastS := S;
  end;
  SB1.Panels[0].Text := Z;
  SB1.Hint 	     := Z;
  if (Emailer1.ErrorCode[saGetStat] <> meOK) then rxTray1.Hint := 'Error!'
					     else rxTray1.Hint := Z;
  Inc(fTotal);
  SB1.Panels[1].Text := 'Checked ' + IntToStr(fTotal) + ' times';
end;

procedure tForm1.ApplyMessage(const aMsg: string);
var
  lM: tEMMessage;
begin
  if (aMsg = '') then begin
    Panel3.Hide;
    if Form2.CB2.Checked then begin
      if DoGetMessage then Memo2.Text := 'Please wait while getting the message...'
		      else Memo2.Text := 'Unabled to get messages right now. Please try later.';
    end
    else begin
      Memo2.Text := 'Click [Get Message] to get this message.';
      GetMessage1.Enabled := True;
    end;
    SaveAs1.Enabled := False;
    Reply1.Enabled  := False;
  end
  else
    if Emailer1.ParseMsg(aMsg, lM) then begin
      Panel3.Show;
      LFrom.Caption    := lM.fFrom;
      LTo.Caption      := lM.fTo;
      LSubject.Caption := lM.fSubject;
      LDate.Caption    := lM.fDate;
      Memo2.Text       := lM.fBody;
      SaveAs1.Enabled  := True;
      GetMessage1.Enabled := False;
      Reply1.Enabled   := True;
    end;
end;

procedure TForm1.Emailer1ActionDone(Sender: TObject; anAction: tEMAction);
begin
  if not (csDestroying in ComponentState) then begin
    DeleteAction(anAction);
    case anAction of
      saGetStat	  : CheckDone;
      saGetMessage: begin
	if (fMessageID >= 0) and (fMessageID < fMessages.Count) then begin
	  fMessages[fMessageID] := EMailer1.MessageBody;
	  if (TC1.TabIndex = fMessageID) then ApplyMessage(EMailer1.MessageBody);
	  rxTray1.Hint := IntToStr(LastS) + ' bytes in ' + IntToStr(LastR) + ' message(s)';
	end;
      end;
      saDeleteMsg: DoCheck;
      saSendMessage: if (Emailer1.ErrorCode[saSendMessage] <> meOK) then
	if Form2.CB3.Checked then fLog.Add(Emailer1.ErrorMessage[saSendMessage]);
    end;
  end;
end;

procedure TForm1.Emailer1ActionStart(Sender: TObject; anAction: tEMAction);
begin
  if not (csDestroying in ComponentState) then begin
    AddAction(anAction);
    RxTray1.Hint := saNames[anAction];
    case anAction of
      saGetStat	   : ;
      saGetMessage : fMessageID := fMsgIndex - 1;
      saDeleteMsg  : fDelMsgID  := fDelMsgInd - 1;
      saSendMessage: ;
    end;
  end;
end;

procedure TForm1.AddAction(anAction: tEMAction);
begin
  fActions.AddObject(saNames[anAction], Pointer(anAction));
  SB1.Panels[2].Text := saNames[anAction];
  Abort1.Enabled := True;
end;

procedure TForm1.DeleteAction(anAction: tEMAction);
var
  i: Integer;
begin
  for i := 0 to fActions.Count - 1 do
    if (tEMAction(fActions.Objects[i]) = anAction) then begin
      fActions.Delete(i);
      Break;
    end;
  if (SB1.Panels[2].Text = saNames[anAction]) then SB1.Panels[2].Text := '';
  Abort1.Enabled := (fActions.Count > 0);
end;

procedure TForm1.BSetClick(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure tForm1.TabChanged;
begin
  if (TC1.TabIndex >= 0) then ApplyMessage(fMessages[TC1.TabIndex])
  else begin
    Panel3.Hide;
    Memo2.Text := '<no messages>';
  end;
end;

procedure TForm1.TC1Change(Sender: TObject);
begin
  TabChanged;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //Emailer1.AbortAllActions;
  fMessages.Free;
  fLog.Free;
  fActions.Free;
  RegSaveFont(FD1.Font, regAppName + '\BaseFont'); 
end;

function tForm1.DoGetMessage: Boolean;
begin
  if (TC1.TabIndex >= 0) then begin
    fMsgIndex := TC1.TabIndex + 1;
    Result := EMailer1.GetMessage(fMsgIndex);
  end
  else Result := False;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  DoGetMessage;
end;

procedure TForm1.Active1Click(Sender: TObject);
begin
  Active1.Checked := not Active1.Checked;
  Emailer1.CheckActive := Active1.Checked;
end;

procedure TForm1.PM1Popup(Sender: TObject);
begin
  Active1.Checked := Emailer1.CheckActive;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Hide;
  CanClose := ThruMenu or (fEndQR = 0);
end;

procedure TForm1.BSaveAsClick(Sender: TObject);
var
  Strs: TStrings;
begin
  with SD1 do
    if Execute then begin
      Strs := TStringList.Create;
      try
	Strs.Text := EMailer1.MessageBody;
	Strs.SaveToFile(FileName);
      finally
	Strs.Free;
      end;
    end;
end;

procedure tForm1.WMQueryEnd(var aMessage: tWMQueryEndSession);
begin
  fEndQR := aMessage.Source;
  aMessage.Result := Integer(CloseQuery and CallTerminateProcs);
end;

procedure tForm1.DoDelete;
begin
  if AskYN('Are you sure you want to delete this message from server?') then
    if (TC1.TabIndex >= 0) then begin
      fDelMsgInd := TC1.TabIndex + 1;
      EMailer1.DelMessage(fDelMsgInd);
    end;
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
  DoDelete;
end;

function GoodEMail(const anAddress: string): string;
var
  i: Integer;
begin
  Result := Trim(anAddress);
  if (Result <> '') then begin
    i := Length(Result);
    if (Result[i] = '>') then begin
      while (i > 1) and (Result[i - 1] <> '<') do Dec(i);
      Result := Copy(Result, i, Length(Result) - 1);
    end;
  end;
end;

procedure tForm1.DoSend(const aTo, aBody: string);
begin
  if AskYN('Send this reply?') then EMailer1.SendMail(GoodEMail(Form2.Edit9.Text), GoodEMail(aTo), aBody);
end;

procedure TForm1.Reply1Click(Sender: TObject);
begin
  //
  if Form3.ComposeReply(LSubject.Caption, LFrom.Caption, Memo2.Text, True) then DoSend(LFrom.Caption, Form3.Memo1.Text);
end;

procedure TForm1.NewMessage1Click(Sender: TObject);
var
  lS: string;
begin
  lS := GetRegStr(regAppName, 'LASTFRIEND', 'my.only@friend.there');
  if InputQuery('Send mail to', 'E-Mail address:', lS) then
    if Form3.ComposeReply('%Subject%', lS, 'Hello!'#13#10#13#10'Goodbye!', False) then begin
      SetRegStr(regAppName, 'LASTFRIEND', lS);
      DoSend(lS, Form3.Memo1.Text);
    end;
end;

procedure TForm1.Emailer1GetPass(Sender: TObject; var aPass: String);
begin
  if not AskPass(aPass) then aPass := '';
end;

procedure tForm1.SetFont;
begin
  Memo2.Font.Assign(FD1.Font);
  Form3.Memo1.Font.Assign(FD1.Font);
  LSubject.Font.Assign(FD1.Font);
end;

procedure TForm1.Font1Click(Sender: TObject);
begin
  if FD1.Execute then SetFont;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  SetFont;
end;

// INITIALIZATION

type
  phWnd = ^hWnd;

function EnumFunc(Wnd: hWnd; lParam: phWnd): Bool; stdcall;
var
  lID: Integer;
begin
  lID := GetWindowLong(Wnd, GWL_USERDATA);
  if (lID = idEMailer) then begin
    lParam^ := Wnd;
    Result  := False;
  end
  else Result := True;
end;

var
  lPrevWnd: hWnd;

initialization

begin
  lPrevWnd := 0;
  EnumWindows(@EnumFunc, Integer(@lPrevWnd));
  if (lPrevWnd <> 0) then begin
    ShowMessage('One E-Mailer is enough!');
    Halt(1);
  end;
end;

end.

