unit uReply;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm3 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Memo1: TMemo;
    PB1: TPaintBox;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure PB1Paint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function ComposeReply(const aSubject, aSender, aSrc: string; IsReply: Boolean): Boolean;
  end;

var
  Form3: TForm3;

implementation

uses uSet;

{$R *.DFM}

function Rfc822DateTime(t : TDateTime) : String;
(*
Author:       Franois PIETTE
EMail:        francois.piette@ping.be   francois.piette@rtfm.be
WebSite:      http://www.rtfm.be/fpiette
Creation:     09 october 1997
Legal issues: Copyright (C) 1997 by Franois PIETTE <francois.piette@ping.be>
*)
var
  I: Integer;
  SaveShortDayNames: array[1..7] of string;
  SaveShortMonthNames: array[1..12] of string;
const
  MyShortDayNames: array[1..7] of string =
      ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
  MyShortMonthNames: array[1..12] of string =
      ('Jan', 'Feb', 'Mar', 'Apr',
       'May', 'Jun', 'Jul', 'Aug',
       'Sep', 'Oct', 'Nov', 'Dec');
begin
  if ShortDayNames[1] = MyShortDayNames[1] then Result := FormatDateTime('ddd, d mmm yyyy hh:mm:ss', t)
  else begin
    { We used a localized Delphi version, the day and motnh names are no }
    { more english names ! We need to save and replace them              }
    for I := Low(ShortDayNames) to High(ShortDayNames) do begin
      SaveShortDayNames[I] := ShortDayNames[I];
      ShortDayNames[I]     := MyShortDayNames[I];
    end;
    for I := Low(ShortMonthNames) to High(ShortMonthNames) do begin
      SaveShortMonthNames[I] := ShortMonthNames[I];
      ShortMonthNames[I]     := MyShortMonthNames[I];
    end;
    Result := FormatDateTime('ddd, d mmm yyyy hh:mm:ss', t);
    for I := Low(ShortDayNames) to High(ShortDayNames) do ShortDayNames[I] := SaveShortDayNames[I];
    for I := Low(ShortMonthNames) to High(ShortMonthNames) do ShortMonthNames[I] := SaveShortMonthNames[I];
  end;
end;

function tForm3.ComposeReply(const aSubject, aSender, aSrc: string; IsReply: Boolean): Boolean;
const
  Bool2Caption: array [Boolean] of string = ('New message', 'Reply');
var
  lS: tStrings;
   i: Integer;
  lU: string;
begin
  lS := tStringList.Create;
  try
    lS.Text := aSrc;
    if IsReply then
      for i := 0 to lS.Count - 1 do lS[i] := '=>' + lS[i];
    lU := aSubject;
    {$B-}
    if IsReply and (Pos('RE:', UpperCase(lU)) <> 1) then lU := 'Re: ' + lU;
    Memo1.Text := 'From: ' + Form2.Edit9.Text + #13#10 +
		  'To: ' + aSender + #13#10 +
		  'Subject: ' + lU + #13#10 +
		  'Date: ' + Rfc822DateTime(Now) + #13#10 +
		  'MIME-Version: 1.0'#13#10 +
		  'Content-Type: text/plain'#13#10#13#10 + lS.Text;
    Caption := Bool2Caption[isReply];
    Result  := (ShowModal = mrOK);
  finally
    lS.Free;
  end;
end;

procedure TForm3.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TForm3.SpeedButton2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TForm3.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    #13: ModalResult := mrOK;
    #27: ModalResult := mrCancel;
  end;
end;

procedure TForm3.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #27) then ModalResult := mrCancel;
end;

procedure DrawVertText(aCanvas: tCanvas; aX, aY: Integer; const aText: string);
{
  this routine:
    Copyright c 1996 by Jurg Lingner, Munich, Germany (jlingner@t-online.de)
}
var
  LFont   : TLogFont;
  hOldFont,
  hNewFont: HFont;
begin
  GetObject(aCanvas.Font.Handle, SizeOf(LFont), Addr(LFont));
  LFont.lfEscapement := 90 * 10;
  hNewFont := CreateFontIndirect(LFont);
  hOldFont := SelectObject(aCanvas.Handle, hNewFont);
  aCanvas.TextOut(aX, aY, aText);
  hNewFont := SelectObject(aCanvas.Handle, hOldFont);
  DeleteObject(hNewFont);
end;

procedure TForm3.PB1Paint(Sender: TObject);
begin
  DrawVertText(PB1.Canvas, 2, PB1.Height - 5, 'Warning!');
  DrawVertText(PB1.Canvas, 20, PB1.Height - 5, 'Don''t modify message''s header!');
end;

end.
